﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using System.Web.Security;
using System.Web.SessionState;
using ExtMvcValidation.Models;

namespace ExtMvcValidation {

	public class Global : HttpApplication {

		protected void Application_Start() {
			AreaRegistration.RegisterAllAreas();
			SetControllerDefaultNamespaces();
			RegisterRoutes(RouteTable.Routes);

			DataAnnotationsModelValidatorProvider.RegisterAdapter(typeof(CustomAttribute), typeof(CustomValidator));
		}

		private static void RegisterRoutes(RouteCollection routes) {

			routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

			routes.MapRoute("Default", "{controller}/{action}/{id}", new {
				controller = "Home",
				action = "Index",
				id = ""
			});
		}

		private static void SetControllerDefaultNamespaces() {
			ControllerBuilder.Current.DefaultNamespaces.Clear();
			ControllerBuilder.Current.DefaultNamespaces.Add("ExtMvcValidation.Controllers");
		}
	}
}